## conky 1.21.8

=== debian/changelog ===
conky (1.21.8-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Wed, 20 Nov 2024 02:00:07 -0800
