=== debian/changelog ===
conky (1.21.9-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 30 Nov 2024 19:59:47 -0800
