=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -4,26 +4,23 @@
 include_directories(${CMAKE_BINARY_DIR})
 include_directories(${conky_includes})
 
-set(test_srcs "test-conky.cc")
+file(GLOB test_srcs test-*.cc)
 
-if(OS_LINUX)
-  set(test_srcs ${test_srcs} test-linux.cc)
+if(NOT OS_LINUX)
+  list(FILTER test_srcs EXCLUDE REGEX ".*linux.*\.cc?")
 endif()
 
-if(OS_DARWIN)
-  set(test_srcs ${test_srcs} test-darwin.cc)
+if(NOT OS_DARWIN)
+  list(FILTER test_srcs EXCLUDE REGEX ".*darwin.*\.cc?")
 endif()
 
-set(test_srcs ${test_srcs} test-core.cc)
-set(test_srcs ${test_srcs} test-diskio.cc)
-set(test_srcs ${test_srcs} test-fs.cc)
-set(test_srcs ${test_srcs} test-gradient.cc)
-set(test_srcs ${test_srcs} test-graph.cc)
-set(test_srcs ${test_srcs} test-colours.cc)
-set(test_srcs ${test_srcs} test-algebra.cc)
+add_library(Catch2 STATIC catch2/catch_amalgamated.cpp)
 
 add_executable(test-conky test-common.cc ${test_srcs})
-target_link_libraries(test-conky conky_core)
+target_link_libraries(test-conky
+  PRIVATE Catch2
+  PUBLIC conky_core
+)
 catch_discover_tests(test-conky)
 
 if(CODE_COVERAGE)
