=== debian/changelog ===
conky (1.22.0-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Thu, 02 Jan 2025 21:26:00 -0800
