## conky 1.22.1

=== debian/changelog ===
conky (1.22.1-1) unstable; urgency=medium

  * New upstream release.
  * Update standards version to 4.7.2, no changes needed.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 16 Mar 2025 12:15:10 -0700
