=== debian/control ===
--- 
+++ 
@@ -40,7 +40,7 @@
  python3-yaml,
  wayland-protocols
 Homepage: https://github.com/brndnmtthws/conky
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/debian/conky.git
 Vcs-Browser: https://salsa.debian.org/debian/conky
 Rules-Requires-Root: no
