=== debian/rules ===
--- 
+++ 
@@ -11,9 +11,12 @@
 
 COMMON_CONF_ARGS=-DCMAKE_BUILD_TYPE=RelWithDebInfo \
                  -DCMAKE_INSTALL_PREFIX=/usr \
-                 -DRELEASE=True \
+                 -DRELEASE=ON \
                  -DBUILD_DOCS=ON \
                  -DBUILD_EXTRAS=ON \
+                 -DMAINTAINER_MODE=OFF \
+                 -DREPRODUCIBLE_BUILD=ON \
+                 -DUSE_CCACHE=OFF \
                  -DCMAKE_C_FLAGS="$(DEB_CFLAGS) $(DEB_CPPFLAGS)" \
                  -DCMAKE_CXX_FLAGS="$(DEB_CXXFLAGS) $(DEB_CPPFLAGS)"
